/*
 * math.c
 *
 *  Created on: Oct 29, 2013
 *      Author: mtk
 */
#include "math.h"

/**
 * FIBN+1 = FIBN + FIBN-1	for  n>0
 * FIB1 = 1
 * FIB0 = 0
 *
 */
/* recursive implementation */
int fibonacci(int N){
	// 1. stop condition
	 if(N==1) return 1;
	 if(N==0) return 0;

	 // 2. recursion
	 return fibonacci(N-1) + fibonacci(N-2);
}

/** Fibonacci iterative implementation **/
int fibonacci_it(int N){
	if(N==0) return 0;
	int fib_2 = 0;
	if(N==1) return 2;
	int fib_1 = 1;

	int i;
	int fib;
	for(i=2; i<=N; ++i){
		fib = fib_1 + fib_2;
		fib_2 = fib_1;
		fib_1 = fib;
	}
	return fib;
}


int binarysearch(int A[], int begin, int end, int x){

	//1. stop condition
	if(begin>=end){
		if(A[begin] == x) return begin;
		else return -1; // NOT_FOUND
	}
	int middle = (end+begin) / 2;
	if( A[middle] == x ) return middle;

	//2. recursion
	if(A[middle] > x){
		return binarysearch(A,begin,middle-1,x);
	}else{
		return binarysearch(A,middle+1,end,x);
	}
}

static void merge(int A[], int p, int mid, int r, int B[]);
static void do_merge_sort(int A[], int p, int r, int B[]);

void merge_sort(int A[], int p, int r){
	int n = r-p+1;
	//int *B = (int*) malloc( n * sizeof(n)); // no limitation in memory
	int B[n];  // may saturate stack memory
	do_merge_sort(A,p,r,B);
}

static void do_merge_sort(int A[], int p, int r, int B[]){
	if( p >= r) return; // already sorted (1 element!!)
	int mid = (p+r)/2;
	do_merge_sort(A,p,mid,B); // run on CPU #1
	do_merge_sort(A,mid+1,r,B);  // run on CPU #2
	merge(A,p,mid,r,B);
}

static void merge(int A[], int p, int mid, int r, int B[]){
	int i = p;
	int j = mid+1;
	int k = 0;
	int n = r-p+1;
//	int *B= (int*)malloc( n * sizeof(int));
	while( i<=mid && j<=r ){
		if( A[i] < A[j] ){
			B[k] = A[i++];
		}else{
			B[k] = A[j++];
		}
		k++;
	}
	while(i<=mid) B[k++] = A[i++];
	while(j<=r) B[k++] = A[j++];
	for(i=0; i<n; i++){
			A[p+i] = B[i];
	}
//	free(B);
}






